<?xml version='1.0' encoding='UTF-8' ?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                template="/templates/admin-template.xhtml">

    <ui:define name="pageTitle">#{msg.bookPageTitle}</ui:define>

    <ui:define name="content">

        <div class="surface-section p-5">
            <div class="card crud-demo">
                <p:toolbar>
                    <p:toolbarGroup>
                        <p:commandButton value="#{msg.bookNewLabel}" icon="pi pi-plus" actionListener="#{beanBook.initObject}"
                                         update=":form:manage-book-content"
                                         oncomplete="PF('manageBookDialog').show()"
                                         styleClass="ui-button-success" style="margin-right: .5rem">
                            <p:resetInput target=":form:manage-book-content"/>
                        </p:commandButton>
                        <p:commandButton id="delete-books-button" value="#{beanBook.deleteButtonMessage}"
                                         icon="pi pi-trash" actionListener="#{beanBook.deleteSelectedBooks}"
                                         styleClass="ui-button-danger" disabled="#{!beanBook.hasSelectedBooks()}"
                                         update="@this">
                            <p:confirm header="#{msg.bookDialogDeleteTitle}" message="#{msg.bookDialogDeleteContent}"
                                       icon="pi pi-exclamation-triangle"/>
                        </p:commandButton>
                    </p:toolbarGroup>
                </p:toolbar>

                <p:dataTable id="dt-books" widgetVar="dtBooks" var="book" value="#{beanBook.books}"
                             reflow="true" styleClass="products-table"
                             selection="#{beanBook.selectedBooks}" rowKey="#{book.id}" paginator="true"
                             rows="10" rowSelectMode="add" paginatorPosition="bottom">
                    <f:facet name="header">
                        <div class="products-table-header">
                            <span class="mr-4" style="font-weight: bold">#{msg.bookTitleTable}</span>

                            <span class="filter-container ui-input-icon-left">
                                    <i class="pi pi-search"/>
                                    <p:inputText id="globalFilter" onkeyup="PF('dtBooks').filter()"
                                                 placeholder="#{msg.bookSearchPlaceholder}"/>
                                </span>

                        </div>
                    </f:facet>

                    <p:ajax event="rowSelect" update=":form:delete-books-button"/>
                    <p:ajax event="rowUnselect" update=":form:delete-books-button"/>
                    <p:ajax event="rowSelectCheckbox" update=":form:delete-books-button"/>
                    <p:ajax event="rowUnselectCheckbox" update=":form:delete-books-button"/>
                    <p:ajax event="toggleSelect" update=":form:delete-books-button"/>

                    <p:column selectionMode="multiple" exportable="false"/>

                    <p:column headerText="#{msg.bookIsbnText}" sortBy="#{book.isbn}" filterBy="#{book.isbn}">
                        <h:outputText value="#{book.isbn}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookTitleText}" sortBy="#{book.title}" filterBy="#{book.title}">
                        <h:outputText value="#{book.title}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookImageText}" exportable="false">
                        <p:graphicImage name="books/#{book.image}" library="images"
                                        styleClass="product-image"/>
                    </p:column>
                    <p:column headerText="#{msg.bookPublicationDateText}" sortBy="#{book.originalPublication}"
                              filterBy="#{book.originalPublication}">
                        <h:outputText value="#{book.originalPublication}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookAuthorText}" sortBy="#{book.author.names}" filterBy="#{book.author.names}">
                        <h:outputText value="#{book.author.names}"/>
                    </p:column>
                    <p:column headerText="#{msg.bookBookTypeText}" sortBy="#{book.bookType.typeName}"
                              filterBy="#{book.bookType.typeName}">
                        <h:outputText value="#{book.bookType.typeName}"/>
                    </p:column>
                    <p:column exportable="false">
                        <p:commandButton icon="pi pi-pencil" update=":form:manage-book-content"
                                         oncomplete="PF('manageBookDialog').show()"
                                         styleClass="edit-button rounded-button ui-button-success mr-1" process="@this">
                            <f:setPropertyActionListener value="#{book}" target="#{beanBook.selectedBook}"/>
                            <p:resetInput target=":form:manage-book-content"/>
                        </p:commandButton>
                        <p:commandButton class="ui-button-warning rounded-button ml-1" icon="pi pi-trash" process="@this"
                                         oncomplete="PF('deleteBookDialog').show()">
                            <f:setPropertyActionListener value="#{book}" target="#{beanBook.selectedBook}"/>
                        </p:commandButton>
                    </p:column>

                </p:dataTable>

                <p:dialog header="#{msg.bookDialogDetailsHeader}" showEffect="fade" modal="true"
                          widgetVar="manageBookDialog" responsive="true">
                    <p:outputPanel id="manage-book-content" class="ui-fluid">
                        <p:outputLabel rendered="#{not empty beanBook.selectedBook}">
                            <div class="grid formgrid ui-fluid">
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="isbn" class="font-medium">#{msg.bookIsbnText}</label>
                                    <p:inputText id="isbn" value="#{beanBook.selectedBook.isbn}" required="true" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="title" class="font-medium">#{msg.bookTitleText}</label>
                                    <p:inputText id="title" value="#{beanBook.selectedBook.title}" required="true" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookImageText}</label>
                                    <div class="flex align-items-center">
                                        <p:graphicImage name="avatars/circle/avatar-f-3.png"
                                                        library="images" alt="Image"
                                                        styleClass="mr-4"/>
                                        <p:fileUpload mode="simple" skinSimple="true" label="Upload Image" auto="true"
                                                      process="@this"/>
                                    </div>
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label for="original-date" class="font-medium">#{msg.bookPublicationDateText}</label>
                                    <p:datePicker id="original-date" value="#{beanBook.selectedBook.originalPublication}" />
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookAuthorText}</label>
                                    <p:selectOneMenu filter="true" filterMatchMode="startsWith">
                                        <f:selectItem itemLabel="Select a Country" itemValue=""/>
                                        <f:selectItem itemLabel="Australia" itemValue="Australia"/>
                                        <f:selectItem itemLabel="Brazil" itemValue="Brazil"/>
                                        <f:selectItem itemLabel="China" itemValue="China"/>
                                        <f:selectItem itemLabel="Egypt" itemValue="Egypt"/>
                                        <f:selectItem itemLabel="France" itemValue="France"/>
                                        <f:selectItem itemLabel="Germany" itemValue="Germany"/>
                                        <f:selectItem itemLabel="India" itemValue="India"/>
                                        <f:selectItem itemLabel="Japan" itemValue="Japan"/>
                                        <f:selectItem itemLabel="Spain" itemValue="Spain"/>
                                        <f:selectItem itemLabel="United States" itemValue="United States"/>
                                    </p:selectOneMenu>
                                </div>
                                <div class="field mb-4 lg:col-6 md:col-12">
                                    <label class="font-medium">#{msg.bookAuthorText}</label>
                                    <p:selectOneMenu filter="true" filterMatchMode="startsWith">
                                        <f:selectItem itemLabel="Select a Country" itemValue=""/>
                                        <f:selectItem itemLabel="Australia" itemValue="Australia"/>
                                        <f:selectItem itemLabel="Brazil" itemValue="Brazil"/>
                                        <f:selectItem itemLabel="China" itemValue="China"/>
                                        <f:selectItem itemLabel="Egypt" itemValue="Egypt"/>
                                        <f:selectItem itemLabel="France" itemValue="France"/>
                                        <f:selectItem itemLabel="Germany" itemValue="Germany"/>
                                        <f:selectItem itemLabel="India" itemValue="India"/>
                                        <f:selectItem itemLabel="Japan" itemValue="Japan"/>
                                        <f:selectItem itemLabel="Spain" itemValue="Spain"/>
                                        <f:selectItem itemLabel="United States" itemValue="United States"/>
                                    </p:selectOneMenu>
                                </div>
                            </div>
                        </p:outputLabel>
                        <!-- Code ends here -->

                    </p:outputPanel>

                    <f:facet name="footer">
                        <p:commandButton value="#{msg.bookSaveButtonLabel}" icon="pi pi-check" actionListener="#{beanBook.saveBook}"
                                         update="manage-book-content" process="manage-book-content @this"/>
                        <p:commandButton value="#{msg.bookCancelButtonLabel}" icon="pi pi-times"
                                         onclick="PF('manageBookDialog').hide()"
                                         class="ui-button-secondary"/>
                    </f:facet>
                </p:dialog>

                <p:confirmDialog widgetVar="deleteBookDialog" showEffect="fade" width="300"
                                 message="#{msg.bookDialogDeleteMessage}" header="#{msg.bookDialogDeleteTitle}" severity="warn">
                    <p:commandButton value="#{msg.bookDialogDeleteYesOption}" icon="pi pi-check" actionListener="#{beanBook.deleteBook}"
                                     process="@this" oncomplete="PF('deleteBookDialog').hide()"/>
                    <p:commandButton value="#{msg.bookDialogDeleteNoOption}" type="button" styleClass="ui-button-secondary" icon="pi pi-times"
                                     onclick="PF('deleteBookDialog').hide()"/>
                </p:confirmDialog>

                <p:confirmDialog global="true" showEffect="fade" width="300">
                    <p:commandButton value="#{msg.bookDialogDeleteYesOption}" type="button" styleClass="ui-confirmdialog-yes"
                                     icon="pi pi-check"/>
                    <p:commandButton value="#{msg.bookDialogDeleteNoOption}" type="button" styleClass="ui-confirmdialog-no ui-button-secondary"
                                     icon="pi pi-times"/>
                </p:confirmDialog>
            </div>
        </div>

    </ui:define>

</ui:composition>
